﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reactive;
using System.Reactive.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The User Control item template is documented at http://go.microsoft.com/fwlink/?LinkId=234236
using ReactiveUI.Sample.Universal.Models;

namespace ReactiveUI.Sample.Universal.MessageBus
{
    public sealed partial class MessageBusUC1 : UserControl
    {
        private int _count;

        public MessageBusUC1()
        {
            this.InitializeComponent();

            var click = Observable.FromEventPattern<RoutedEventArgs>(ClickMessageButton, "Click")
                        .Do(x => _count++)
                        .Do(x => ((Button)x.Sender).Content = "Click Message " + _count);
            ReactiveUI.MessageBus.Current.RegisterMessageSource(click);

        }

        private void SendMessageButton_Click(object sender, RoutedEventArgs e)
        {
            var person = new PersonModel()
            {
                Name = "kaki104",
                Age = _count,
                Sex = _count % 2 == 0
            };
            ReactiveUI.MessageBus.Current.SendMessage(person);
        }

    }
}
